#include <windows.h>
#include <shlwapi.h>
#include <d3d9.h>

#pragma comment(lib, "shlwapi.lib")

#pragma pack(4)

struct SWRFONT_DESC
{
	char FaceName[0x100];
	BYTE res_1CC;  /* color1 */
	BYTE res_1CB;
	BYTE res_1CA;
	BYTE res_1C9;  /* color2 */
	BYTE res_1C8;
	BYTE res_1C7;
	DWORD res_1C4; /* height */
	DWORD res_1C0; /* weight */
	BYTE res_1BC;  /* italic */
	BYTE res_1BB;
	BYTE res_1BA;
	DWORD res_1B8;
	DWORD res_1B4;
	DWORD res_1B0;
	DWORD res_1AC;
	DWORD res_1A8;
};

struct SWRVERTEX
{
	float x, y, z;
	float rhw;
	D3DCOLOR color;
	float u, v;
};

#define FVF_SWRVERTEX (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)

template<typename TDest, typename TSrc>
__forceinline 	
TDest dangerous_cast(TSrc src) {
	union {
		TDest dst;
		TSrc  src;
	} c;
	c.src = src;
	return c.dst;
}

class C {};
#define Ccall(p,f,r,T) (((C*)p)->*dangerous_cast<r##(C::*)##T>(f))

typedef void (__fastcall *fastfunc)(void *p);
typedef int  (__fastcall *fastfuncr)(void *p);
typedef bool (__fastcall *fastfuncb)(void *p);

// tHgtB[h
#define font_ctor(p) \
	Ccall(p,0x410E80,void,())()
#define font_dtor(p) \
	Ccall(p,0x410F10,void,())()
#define font_setIndirect(p, pdesc) \
	Ccall(p,0x410FF0,void,(void*))(pdesc)
// eNX`}l[W
#define textureMgr_createTextTexture(p, ret, str, pdesc ,width ,height) \
	Ccall(p,0x405000,int*,(int*, LPCSTR, void*, int, int))(ret, str, pdesc, width, height)
#define textureMgr_loadTexture(p, ret, path, unk1, unk2) \
	Ccall(p,0x404F90,int*,(int*, LPCSTR, void*, void*))(ret, path, unk1, unk2)
#define textureMgr_remove(p, id) \
	Ccall(p,0x405070,void*,(int))(id)
#define textureMgr_get(p, id) \
	Ccall(p,0x402710,IDirect3DTexture9**,(int))(id)
#define CRenderer_End(p) ((fastfunc)0x401040)(p)
// og}l[W
#define CBattleManager_Create(p) ((fastfunc)s_origCBattleManager_OnCreate)(p)
#define CBattleManager_Render(p) ((fastfunc)s_origCBattleManager_OnRender)(p)
#define CBattleManager_Destruct(p, dyn) \
	Ccall(p,s_origCBattleManager_OnDestruct,void*,(int))(dyn)

#define CBattleManager_DetermineWinner(p) ((fastfunc)s_origCBattleManager_OnDetermineWinner)(p)

// CHandleManager<IDirect3DTexture *>
#define g_texMgr ((void *)0x6DDCD0)
// IDirect3DDevice9
#define g_pd3dDev (*((IDirect3DDevice9**)0x6DE0D8))

#define g_mode (*(DWORD*)0x6D72CC)
#define g_subMode (*(DWORD*)0x06D72C4)

struct CBattleManager {
	virtual void * Destruct(int dynamic) = 0;
	virtual void LoadChars() = 0;
	virtual void nop() = 0;
	virtual void ProcessMenu() = 0;
	virtual void ProcessMenu1() = 0;
	virtual void ProcessMenu2() = 0;
	virtual void ProcessMenu3() = 0;
	virtual void ProcessMenu4() = 0;
	virtual void ProcessMenu5() = 0;
	virtual void ProcessMenu6() = 0;
	virtual void ProcessMenu7() = 0;
	virtual void unkproc1() = 0;
	virtual void DetermineWinner() = 0;
	virtual void SetBattleMode(int mode) = 0;
};

static DWORD s_origCBattleManager_OnCreate;
static DWORD s_origCBattleManager_OnDestruct;
static DWORD s_origCBattleManager_OnRender;
static DWORD s_origCBattleManager_OnDetermineWinner;
static DWORD s_origCBattleManager_Size;

static int  s_raiseCountDef;
static int  s_raiseCountRep;
static int  s_raiseCount;
static bool s_enabled;

extern "C"
int _fltused = 1;

static void operator delete(void* p) {}

class CNumberSprite
{
public:
	CNumberSprite() {
		char font[0x1A4]; // Ƃ 0x1A4
		font_ctor(font);

		SWRFONT_DESC sfdesc;
		strcpy(sfdesc.FaceName, (char *)0x69F154);
		sfdesc.res_1CC = 0xFF;   // color 1
		sfdesc.res_1CB = 0xA0;
		sfdesc.res_1CA = 0xFF;
		sfdesc.res_1C9 = 0xA0;   // color 2
		sfdesc.res_1C8 = 0xFF;
		sfdesc.res_1C7 = 0xFF;
		sfdesc.res_1C4 = 0x0E;   // width
		sfdesc.res_1C0 = 400;    // bold
		sfdesc.res_1BC = 0;
		sfdesc.res_1BB = 1;      // shadow
		sfdesc.res_1BA = 0;
		sfdesc.res_1B8 = 100000; // ?
		sfdesc.res_1B4 = 0;
		sfdesc.res_1B0 = 0;
		sfdesc.res_1AC = 0;      // char gap
		sfdesc.res_1A8 = 2;      // ?
		font_setIndirect(font, &sfdesc);

		textureMgr_createTextTexture(g_texMgr, &m_texID, "OPQRSTUVWX", font, 256, 16);
		
		font_dtor(font);
	}

	~CNumberSprite() {
		textureMgr_remove(g_texMgr, m_texID);
	}

private:
	void RenderDigit(IDirect3DTexture9 *tex, int x, int y, int d)
	{
		// ߂ǂȂ̂ŒłŁEEE
		const SWRVERTEX vertices[] = {
			{ x,      y,      0.0f, 1.0f, 0xffffffff, d * 0.0546875f,       0.0f },
			{ x + 15, y,      0.0f, 1.0f, 0xffffffff, (d + 1) * 0.0546875f, 0.0f },
			{ x + 15, y + 16, 0.0f, 1.0f, 0xffffffff, (d + 1) * 0.0546875f, 1.0f },
			{ x,      y + 16, 0.0f, 1.0f, 0xffffffff, d * 0.0546875f      , 1.0f },
		};
		g_pd3dDev->SetTexture(0, tex);
		g_pd3dDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, vertices, sizeof(SWRVERTEX));
	}

public:
	// E獶
	void Render(int number, int x, int y)
	{
		char digits[32];
		int  diglen = 0;
		do {
			digits[diglen++] = number % 10;
			number /= 10;
		} while(number);

		IDirect3DTexture9 **tex = textureMgr_get(g_texMgr, m_texID);
		for(int i = 1; i <= diglen; ++i) {
			RenderDigit(*tex, x - i * 15, y, digits[i - 1]);
		}
	}

	static void * operator new(size_t size, void* buf) { return buf; }
	static void operator delete(void* p, void* buf) {}

private:
	int m_texID;
};

void __fastcall CBattleManager_DrawMyBack(int x, int y)
{
	const SWRVERTEX vertices[] = {
		{ x,      y,      0.0f, 1.0f, 0xa0d0d0d0, 0.0f, 0.0f },
		{ x + 45, y,      0.0f, 1.0f, 0xa0d0d0d0, 1.0f, 0.0f },
		{ x + 50, y + 16, 0.0f, 1.0f, 0xa0808080, 1.0f, 1.0f },
		{ x + 5,  y + 16, 0.0f, 1.0f, 0xa0808080, 0.0f, 1.0f },
	};
	g_pd3dDev->SetTexture(0, NULL);
	g_pd3dDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, vertices, sizeof(SWRVERTEX));
}

void __fastcall CBattleManager_OnDetermineWinner(void *This)
{
	if(!s_enabled) {
		CBattleManager_DetermineWinner(This);
		return;
	}

	int &m_p1win = *(int*)((char*)This + s_origCBattleManager_Size + 0);
	int &m_p2win = *(int*)((char*)This + s_origCBattleManager_Size + 4);

	char *p1Obj = *(char**)((char *)This + 0xC);
	char *p2Obj = *(char**)((char *)This + 0x10);
	char &p1win = *(p1Obj + 0x4E4);
	char p1down = *(p1Obj + 0x4E5);
	char &p1end = *(p1Obj + 0x4E7);
	char &p2win = *(p2Obj + 0x4E4);
	char p2down = *(p2Obj + 0x4E5);
	char &p2end = *(p2Obj + 0x4E7);
	char &etype = *((char *)This + 0x5B0);

	// JEg
	int matchCount = s_raiseCount - 1;
	if(p1down == 1 && p2down == 1) {
		if(m_p1win < matchCount && m_p2win < matchCount)
			++m_p1win; ++m_p2win;
	} else if(p1down == 1 && p2down == 0) {
		++m_p2win;
	} else if(p1down == 0 && p2down == 1) {
		++m_p1win;
	} else return;

	if(m_p1win == s_raiseCount || m_p2win == s_raiseCount) {
		// ʂCɏo
		if(m_p1win == s_raiseCount) {
			// p2킽
			p1win = 2; p2win = 0; p2end = 1;
		} else {
			// p1킽
			p2win = 2; p1win = 0; p1end = 1;
		}
		etype = 2;
		((CBattleManager*)This)->SetBattleMode(4);
	} else {
		// ҃}b`|Cg̎ŏI
		if(m_p1win == matchCount && m_p1win == m_p2win) etype = 2;
		else etype = 1;
		((CBattleManager*)This)->SetBattleMode(3);
	}
}

void * __fastcall CBattleManager_OnCreate(void *This)
{
	// super
	CBattleManager_Create(This);

	if(g_subMode == 1 && g_mode == 3 && s_raiseCountDef != 2) {
		// vs p2
		s_raiseCount = s_raiseCountDef;
		s_enabled = true;
	} else if(g_subMode == 2 && g_mode == 3 && s_raiseCountRep != 2) {
		// Replay
		s_raiseCount = s_raiseCountRep;
		s_raiseCountRep = 2;
		s_enabled = true;
	} else {
		// ȊO
		s_enabled = false;
	}

	if(s_enabled) {
		int &m_p1win = *(int*)((char*)This + s_origCBattleManager_Size + 0);
		int &m_p2win = *(int*)((char*)This + s_origCBattleManager_Size + 4);
		CNumberSprite *m_spr = (CNumberSprite*)((char*)This + s_origCBattleManager_Size + 8);

		m_p1win = m_p2win = 0;
		new (m_spr) CNumberSprite;
	}

	return This;
}

void __fastcall CBattleManager_OnRender(void *This)
{
	CBattleManager_Render(This);
	if(s_enabled) {
		// ߑ䎌̎͒eĂ
		int m_mode = *(int*)((char*)This + 0x88);
		if(m_mode != 5 && m_mode != 6) {
			int &m_p1win = *(int*)((char*)This + s_origCBattleManager_Size + 0);
			int &m_p2win = *(int*)((char*)This + s_origCBattleManager_Size + 4);
			CNumberSprite *m_spr = (CNumberSprite*)((char*)This + s_origCBattleManager_Size + 8);

			// p1
			CBattleManager_DrawMyBack(165, 56);
			m_spr->Render(m_p1win, 210, 56);
			// p2
			CBattleManager_DrawMyBack(435, 56);
			m_spr->Render(m_p2win, 480, 56);
		}
	}
}

void * __fastcall CBattleManager_OnDestruct(void *This, int, int dyn)
{
	if(s_enabled) {
		CNumberSprite *spr = (CNumberSprite*)((char*)This + s_origCBattleManager_Size + 8);
		spr->~CNumberSprite();
	}

	return CBattleManager_Destruct(This, dyn);
}

DWORD WINAPI Replay_OnWriteFile(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWrite, LPOVERLAPPED lpOverlapped)
{
	DWORD ret;
	// L̂ݔ
	if(!s_enabled) {
		return WriteFile(hFile, lpBuffer, nNumberOfBytesToWrite, lpNumberOfBytesWrite, lpOverlapped);
	}

	if(nNumberOfBytesToWrite == 4) {
		// o[Wߋ肳ɂ
		*(DWORD*)lpBuffer = 0xE9;
		ret = WriteFile(hFile, lpBuffer, nNumberOfBytesToWrite, lpNumberOfBytesWrite, lpOverlapped);
	} else if(nNumberOfBytesToWrite == 10) {
		// wb_
		ret = WriteFile(hFile, lpBuffer, nNumberOfBytesToWrite, lpNumberOfBytesWrite, lpOverlapped);
		// ǉ`
		WriteFile(hFile, &s_raiseCount, 4, lpNumberOfBytesWrite, lpOverlapped);
	} else {
		// 悭킩Ȃ
		ret = WriteFile(hFile, lpBuffer, nNumberOfBytesToWrite, lpNumberOfBytesWrite, lpOverlapped);
	}
	return ret;
}

DWORD WINAPI Replay_OnReadFile(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped)
{
	static bool s_modProfile = false;

	DWORD ret;
	ret = ReadFile(hFile, lpBuffer, nNumberOfBytesToRead, lpNumberOfBytesRead, lpOverlapped);
	if(nNumberOfBytesToRead == 4) {
		// o[Wߋ肳
		if(*(DWORD*)lpBuffer == 0xE9) {
			// o[WɌ
			*(DWORD*)lpBuffer = ((DWORD (*)())0x437D90)();
			// t
			s_modProfile = true;
		} else {
			// Ȃ̂łbȂ
			s_modProfile = false;
		}
	} else if(nNumberOfBytesToRead == 10) {
		// wb_
		if(s_modProfile) {
			// SwraiseŃvȂǉdCȂēǂ
			ReadFile(hFile, &s_raiseCountRep, 4, lpNumberOfBytesRead, lpOverlapped);
		}
	}
	return ret;
}

const static DWORD s_Replay_OnWriteFile = (DWORD)Replay_OnWriteFile;
const static DWORD s_Replay_OnReadFile = (DWORD)Replay_OnReadFile;

void LoadSettings(LPCSTR profilePath)
{
	s_raiseCountDef = GetPrivateProfileInt("SWRaise", "Count", 2, profilePath);
	if(s_raiseCountDef < 2 || s_raiseCountDef > 999) s_raiseCountDef = 2;
}

BOOL Hook(HMODULE hModule)
{
	char profilePath[1024 + MAX_PATH];

	GetModuleFileName(hModule, profilePath, 1024);
	PathRemoveFileSpec(profilePath);
	PathAppend(profilePath, "swraise.ini");
	LoadSettings(profilePath);

	s_raiseCountRep = 2;

	DWORD old;
	::VirtualProtect((PVOID)0x401000, 0x29D000, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCBattleManager_Size = *(DWORD*)0x436BF2;
	*(DWORD*)0x436BF2 += sizeof(CNumberSprite) + 8;

	s_origCBattleManager_OnCreate = *(DWORD*)0x436C11 + (0x436C10 + 5);
	*(DWORD*)0x436C11 = dangerous_cast<DWORD>(CBattleManager_OnCreate) - (0x436C10 + 5);

	*(DWORD*)0x4282ED = (DWORD)&s_Replay_OnWriteFile;
	*(DWORD*)0x42A732 = (DWORD)&s_Replay_OnReadFile;
	::VirtualProtect((PVOID)0x401000, 0x29D000, old, &old);

	::VirtualProtect((PVOID)0x69E000, 0x23000, PAGE_EXECUTE_WRITECOPY, &old);
	s_origCBattleManager_OnDestruct = *(DWORD*)0x69F46C;
	*(DWORD*)0x69F46C = dangerous_cast<DWORD>(CBattleManager_OnDestruct);
	s_origCBattleManager_OnDetermineWinner = *(DWORD*)0x69F49C;
	*(DWORD*)0x69F49C = dangerous_cast<DWORD>(CBattleManager_OnDetermineWinner);
	s_origCBattleManager_OnRender = *(DWORD*)0x69F4A4;
	*(DWORD*)0x69F4A4 = dangerous_cast<DWORD>(CBattleManager_OnRender);
	::VirtualProtect((PVOID)0x69E000, 0x23000, old, &old);

	::FlushInstructionCache(GetCurrentProcess(), NULL, 0);

	return TRUE;
}

extern "C"
int APIENTRY DllMain(HMODULE hModule, DWORD fdwReason, LPVOID lpReserved)
{
	return (fdwReason == DLL_PROCESS_ATTACH) ? Hook(hModule) : TRUE;
}
